{$apptype CONSOLE}
{$R+,Q+,O-}
{$ASSERTIONS ON}
uses
    TestlibD, Sysutils;

const
    MAX_N = 100;

type
	TOfficial = record
    	cost : integer;
        deps : array[1..MAX_N] of boolean;
        flag : boolean;
    end;

var
	n : integer;
    offs : array[1..MAX_N] of TOfficial;
    i, j, k, q : integer;

    jcost, jn : integer;

    pcost, pn : integer;

begin
	n := inf.ReadInteger;
    for i := 1 to n do begin
    	offs[i].cost := inf.ReadInteger;
        offs[i].flag := false;
        k := inf.ReadInteger;
        for j := 1 to k do begin
            q := inf.ReadInteger;
            offs[i].deps[q] := true;
        end;
    end;

    jcost := 0;
    jn := ans.ReadInteger;
    for i := 1 to jn do begin
    	j := ans.ReadInteger;
        inc(jcost, offs[j].cost);
    end;

    pn := ouf.ReadInteger;
    if (pn < 0) or (pn > n) then
    	Quit(_WA, format('Illegal number of officials to visit: %d', [pn]));

    pcost := 0;
    for i := 1 to pn do begin
    	j := ouf.ReadInteger;
        if (j < 1) or (j > n) then
	    	Quit(_WA, format('Step %d, illegal official id: %d', [i, j]));
        if offs[j].flag then
	    	Quit(_WA, format('Step %d, official %d is already visited', [i, j]));
		for k := 1 to n do
        	if offs[j].deps[k] and not offs[k].flag then
		    	Quit(_WA, format('Step %d, cannot visit %d prior to visiting %d', [i, j, k]));
        offs[j].flag := true;
        inc(pcost, offs[j].cost);
    end;

    if pcost < jcost then
    	Quit(_WA, format('Not an optimial schedule: %d instead of %d', [pcost, jcost]));
    if pcost = jcost then
    	Quit(_OK, format('n = %d, cost = %d', [n, jcost]));
    if pcost > jcost then
    	Quit(_Fail, format('Oops, %d > %d', [pcost, jcost]));
end.

