{$apptype CONSOLE}
{$R+,Q+,O-}
{$ASSERTIONS ON}
{$define FILE_IO}
uses
    Math, SysUtils;

const
    INFINITY = maxint div 2;

    MAX_N = 100;
    MAX_COST = 10000;

type
	TOfficial = record
    	cost : integer;
        deps : array[1..MAX_N] of boolean;
    end;

var
	n : integer;
    offs : array[1..MAX_N] of TOfficial;

	curCost : integer;
    bestCost : integer;

    curAnsLen, ansLen : integer;
    curAns, ans : array[1..MAX_N] of integer;
    curTake : array[1..MAX_N] of boolean;

procedure ReadInput;
var
	i, j, k, q : integer;

begin
{$ifdef FILE_IO}
	reset(input, 'officials.in');
{$endif}

    read(n);
    assert((n >= 1) and (n <= MAX_N));
    assert(eoln);
    readln;

    fillchar(offs, sizeof(offs), 0);

    for i := 1 to n do begin
    	read(offs[i].cost);
        assert(abs(offs[i].cost) <= MAX_COST);
        assert(not eoln);
        read(k);
        assert((k >= 0) and (k <= MAX_N));
        for j := 1 to k do begin
        	assert(not eoln);
            read(q);
            assert((q >= 1) and (q <= n));
            assert(not offs[i].deps[q]);
            offs[i].deps[q] := true;
        end;
        assert(eoln);
        readln;
    end;
end;

procedure Solve;

	function IsOK(i : integer) : boolean;
    var
    	j : integer;

    begin
    	for j := 1 to n do
        	if offs[i].deps[j] and not curTake[j] then begin
            	result := false;
                exit;
        	end;
        result := true;
    end;

	procedure Search;
    var
    	i : integer;

    begin
    	if curCost > bestCost then begin
        	bestCost := curCost;
        	ans := curAns;
            ansLen := curAnsLen;
        end;

		for i := 1 to n do
        	if not curTake[i] and IsOK(i) then begin
				inc(curAnsLen);
                curAns[curAnsLen] := i;
                inc(curCost, offs[i].cost);
                curTake[i] := true;
                Search;
                curTake[i] := false;
                dec(curAnsLen);
                dec(curCost, offs[i].cost);
            end;
    end;

begin
	bestCost := -INFINITY;
    curCost := 0;
    curAnsLen := 0;
    fillchar(curTake, sizeof(curTake), false);
    Search;
end;

procedure WriteOutput;
var
	i : integer;

begin
{$ifdef FILE_IO}
	rewrite(output, 'officials.out');
{$endif}
    writeln(ansLen);
    for i := 1 to ansLen do
		write(ans[i], ' ');
    writeln;
end;

begin
    ReadInput;
    Solve;
    WriteOutput;
end.

