#define _CRT_SECURE_NO_DEPRECATE

#pragma comment(linker, "/STACK:65888000")

#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <sstream>
#include <cstdio>
#include <memory.h>

#define pii pair<int,int>
#define int64 long long
#define ll long long
#define INF 1000000000
#define ld long double
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define forv(i, v) for(int i = 0; i < (int)v.size(); i++)
#define ford(i, n) for(int i = (int)(n - 1); i >= 0; i--)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)
#define all(a) a.begin(),a.end()
#define norm(a) sort(a);a.erase(unique(all(a)),a.end())
#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int64 INF64 = (int64)1e18;
const ld EPS = 1e-8;
const ld PI = 3.1415926535897932384626433832795;

using namespace std;

set<pii> was;
void genHaos(int n, int cnt, int X, int Y) {
        int x = rand() % X - rand() % X;
        int y = rand() % Y - rand() % Y;
	forn(i, n) {
	        cout << x << " " << y << endl;
		was.insert(mp(x, y));
		do{
                   x = rand() % X - rand() % X;
                   y = rand() % Y - rand() % Y;
		}while(was.count(mp(x, y)) > 0);
	}
}
void genCircle(int n, int cnt, int X, int Y) {
	forn(i, n) {
		int x = int(X * cos(PI * i * 2 / n));
		int y = int(X * sin(PI * i * 2 / n));
		cout << x << " " << y << endl;
	}
}

void genLine(int n, int cnt, int X, int Y) {
	if (cnt == 1) {
		int x = rand() % X - rand() % X;
		int y = rand() % Y - rand() % Y;
		int dx = rand() % 10 - rand() % 10;
		int dy = rand() % 10 - rand() % 10;
		forn(i, n) {
			cout << x << " " << y << endl;
			x += (rand() % 5 + 1) * dx;
			y += (rand() % 5 + 1) * dy;
		}
		return;
	}
	if (cnt == 2) {
		cout << -10000 << " " << -10000 << endl;
		cout << -10000 << " " << 10000 << endl;
		forn(i, n - 2)
			cout << 9875 << " " << i * 10 + 17 << endl;
	}
}

void genCross(int n, int cnt, int X, int Y) {
	int nd = n / 2, md = n - nd;
	int x = -X, y = -Y;
	int step = min((X + X) / nd, (Y + Y) / nd);
	forn(i, nd){
		cout << x << " " << y << endl;
		was.insert(mp(x, y));
		x += step;
		y += step;
	}
	x = X, y = -Y;
	forn(i, md){
		while(was.count(mp(x, y)) > 0){
			x -= step;
			y += step;
		}
		cout << x << " " << y << endl;
		was.insert(mp(x, y));
		x -= step;
		y += step;
	}
}

void genSpecial(int n, int cnt, int X, int Y) {
	int dx[8] = {0, 0, 1, -1};
	int dy[8] = {1, -1, 0, 0};
	fore(i, 4, 8){
		dx[i] = rand() % 6 - rand() % 6;
		dy[i] = rand() % 6 - rand() % 6;
	}
	int x = rand() % X - rand() % X;
	int y = rand() % Y - rand() % Y;
	forn(i, n) {
		cout << x << " " << y << endl;
		was.insert(mp(x, y));
		do{
			int p = rand() % 8;
			x += dx[p];
			y += dy[p];
		}while(was.count(mp(x, y)) > 0);
	}
}

int main(int argc, char* argv[])
{
#ifndef ONLINE_JUDGE
	//freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#endif

	// argv contains N, type, [, cnt] Maxx, Maxy, seed
	// type is "circle", "line", "cross", "special", "haos"
	stringstream ss;

	
	forn(i, 6)
		ss << argv[i + 1] << " ";

	int n, cnt, maxx, maxy, seed;
	string type;
	ss >> n >> type >> cnt >> maxx >> maxy >> seed;
	if (seed >= 0)
		srand(seed);

	cout << n << endl;

	if (type == "circle")
		genCircle(n, cnt, maxx, maxy);
	if (type == "line")
		genLine(n, cnt, maxx, maxy);
	if (type == "cross")
		genCross(n, cnt, maxx, maxy);
	if (type == "special")
		genSpecial(n, cnt, maxx, maxy);
	if (type == "haos")
		genHaos(n, cnt, maxx, maxy);
	return 0;
}