#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cstdio>
#include <memory.h>

#define pii pair<int,int>
#define int64 long long
#define ll long long
#define ld double
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define fore(i, a, b) for(int i = (int)a; i < (int)b; i++)
#define mp make_pair
#define pb push_back
#define x first
#define y second
#define SQR(x) ((x)*(x))
#define ensure(condition) if (!(condition)) fprintf(stderr, "failed: %s\n", #condition), exit(239)

const ld EPS = 1e-8;
const int MAXN = 121;
const int MAXX = 10000;

using namespace std;

int n;

struct mask{
	pair<int64, int64> my;
	mask(int64 a, int64 b) {
		my = mp(a, b);
	}
	mask(){	}
	inline void addBit(int j){
		if (j < (MAXN >> 1))
			my.x |= (1ll << j);
		else
			my.y |= (1ll << (j - (MAXN >> 1)));
	}
	bool operator==(const mask &b) {
		return my.x == b.my.x && my.y == b.my.y;
	}
};

inline mask anding(const mask &a, const mask &b) {
	return mask((a.my.x & b.my.x), (a.my.y & b.my.y));
}

struct line{
	ld a, b, c;
	line(){ };
	line(pii P, pii Q) {
		a = P.y - Q.y, b = Q.x - P.x;
		ld norm = sqrt(a * a + b * b);
		a /= norm;
		b /= norm;
		c = - (a * P.x + b * P.y);
	}
	inline ld signDistTo(pii P) {
		return a * P.x + b * P.y + c;
	}
	inline ld distTo(pii P) {
		return abs(signDistTo(P));
	}
};

ld dists[MAXN * (MAXN + 1) * MAXN / 2];
int dists_cnt;
pii p[MAXN];
mask cur_mask[MAXN][MAXN][MAXN];
short num[MAXN][MAXN][MAXN];
line lines[2];
int a[MAXN];
int asize;
bool vvp[MAXN][MAXN][MAXN];

int sorted_points[MAXN][MAXN];

inline int dist2(int i, int j) {
	return SQR(p[i].x - p[j].x) + SQR(p[i].y - p[j].y);
}
inline ld dist(int i, int j) {
	return sqrt(1. * dist2(i, j));
}
inline int vp(const pii &a, const pii &b, const pii &c) {
	return (b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y);
}
int sel;
bool cmp(const int &aa, const int &bb){
	pii a = p[aa], b = p[bb];
	ld an_a = atan2(0. + a.y - p[sel].y, 0. + a.x - p[sel].x);
	ld an_b = atan2(0. + b.y - p[sel].y, 0. + b.x - p[sel].x);
	if (abs(an_a - an_b) > EPS)
		return an_a < an_b;
	return dist2(sel, aa) < dist2(sel, bb);
}

ld sgn(ld d) {
	if (d > EPS)
		return 1;
	if (d < -EPS)
		return -1;
	return 0;
}

inline line getLine(const line &l, const pair<ld, ld> &p, ld R = 0) {
	line res;
	res.a = l.a, res.b = l.b;
	res.c = 0 - l.a * p.x - l.b * p.y;
	return res;
}

inline bool ok(int pos) {
	ld R = dists[pos];
	bool used[MAXN];
	forn(i, n) {
		fore(j, i + 1, n) {
			line l(p[i], p[j]);
			fore(sig, -1, 2) {
				memset(used, 0, sizeof used);	

				forn(k, n) {
					ld dist = l.signDistTo(p[k]);
					used[k] = (!(dist < -EPS || dist > R+EPS) && sig > 0)||
						      (!(dist > EPS || dist < -R-EPS) && sig < 0);
				}
				// constructing convex hull
				int id = -1, asize = 0;
				forn(k, n){
					if (!used[k] && (id == -1 || (p[a[id]].x > p[k].x || p[a[id]].x == p[k].x && p[a[id]].y > p[k].y)))
						id = asize;
					if (!used[k])
						a[asize++] = k;
				}
				lines[0] = getLine(l, mp(p[i].x + l.a * sig * R / 2, p[i].y + l.b * sig * R / 2), sig * R / 2);
				if(id < 0)
					lines[1] = getLine(line(mp(0, 0), mp(1, 0)), mp(0, 0), sig * R / 2);
				else{
					mask have(0, 0);
					forn(k, n)
						if (used[k])
							have.addBit(k);

					swap(a[id], a[0]);

					asize = 1;
					fore(k, 1, n) {
						if (!used[sorted_points[a[0]][k]])
							a[asize++] = sorted_points[a[0]][k];
					}

					int ch[MAXN];
					int chsize = 0;
					forn(k, asize){
						ch[chsize++] = a[k];
						while(chsize > 2 && vvp[ch[chsize - 3]][ch[chsize - 2]][ch[chsize - 1]]){
							ch[chsize - 2] = ch[chsize - 1];
							--chsize;
						}
					}
					ch[chsize++] = ch[0];

					//

					forn(k, chsize - 1) {
						int ii = ch[k], jj = ch[k + 1];
						line l2(p[ch[k]], p[ch[k + 1]]);
						if (ii > jj) swap(ii, jj);
						int le = 0, ri = n - 1, bad = -1;
						while(le <= ri) {
							int mi = (le + ri) >> 1;
							if (anding(cur_mask[ii][jj][mi], have)==cur_mask[ii][jj][mi]){
								le = mi + 1;
							}else{
								bad = mi;
								ri = mi - 1;
							}
						}
						if(bad >= 0) bad = num[ii][jj][bad];
						if (bad == -1 || l2.distTo(p[bad]) <= R + EPS) {
							ld sig2 = sgn(l2.signDistTo(p[bad]));
							lines[1] = getLine(l2, mp(p[ch[k]].x + l2.a * sig2 * R / 2, p[ch[k]].y + l2.b * sig2 * R / 2),
								R / 2 * sig2);
							return true;
						}
					}
				}
				sig++;
			}
		}
	}
	return false;
}

bool ldcmp(ld a, ld b) {
	return abs(a - b) < EPS;
}

int main()
{
	freopen("gophers.in", "rt", stdin);
	//freopen("gophers.out", "wt", stdout);

	cout.precision(12);
	cout.setf(ios::fixed);

	cin >> n;
	ensure(1 <= n && n < MAXN);
	forn(i, n){
		cin >> p[i].x >> p[i].y;
		ensure (-MAXX <= p[i].x && p[i].x <= MAXX);
		ensure (-MAXX <= p[i].y && p[i].y <= MAXX);
		forn(j, i)
			ensure (p[i].x != p[j].x || p[i].y != p[j].y);
	}

        if (n < 5){
            puts("0");
            return 0;
        }

	forn(i, n)
		forn(j, n)
		forn(k, n)
		vvp[i][j][k] = vp(p[i], p[j], p[k]) < 0;

	forn(i, n)
		forn(j, i){
			line l (p[i], p[j]);
			pair<double, int> v[MAXN];
			int vsz = 0;
			forn(k, n) {				
				dists[dists_cnt++] = l.distTo(p[k]);
				v[vsz++] = mp(l.distTo(p[k]), k);
			}
			sort(v, v + vsz);
			reverse(v, v + vsz);
			mask cur(0, 0);
			forn(k, n) {
				cur.addBit(v[k].y);
				cur_mask[j][i][k] = cur;
				num[j][i][k] = v[k].y;
			}
		}
	sort(dists, dists + dists_cnt);
	dists_cnt = int(unique(dists, dists + dists_cnt, ldcmp) - dists);
	forn(i, n) {
		forn(j, n)
			sorted_points[i][j] = j;
		swap(sorted_points[i][0], sorted_points[i][i]);
		sel = i;
		sort(sorted_points[i] + 1, sorted_points[i] + n, cmp);
	}

	int l = 0, r = dists_cnt - 1, res = -1;
	while(l <= r) {
		int m = (l + r) >> 1;
		if (ok(m))
			res = m, r = m - 1;			
		else
			l = m + 1;
	}
	ok(res);



cout << dists[res] << endl;
#ifdef _DEBUG
forn(i, 2)
cout << lines[i].a << " " << lines[i].b << " " << lines[i].c << "\n";
puts("");
#endif

	forn(i, 2) {
		line m = lines[i];
		ld x1, x2, y1, y2;
		if (abs(m.a) < EPS) {
			y1 = y2 = -m.c / m.b;
			x1 = 0, x2 = 1;
		}else{
			if (abs(m.b) < EPS) {
				x1 = x2 = -m.c / m.a;
				y1 = 0, y2 = 1;
			}else {
				vector<pair<ld, ld> > v;
				while(true){
					x1 = -MAXX * 2;
					y1 = (-m.c - m.a * x1) / m.b;
					if (y1 >= -MAXX * 2 - EPS && y1 <= MAXX * 2 + EPS)v.pb(mp(x1, y1));
					x1 = MAXX * 2;
					y1 = (-m.c - m.a * x1) / m.b;
					if (y1 >= -MAXX * 2 - EPS && y1 <= MAXX * 2 + EPS)v.pb(mp(x1, y1));
					if (v.size() == 2)
						break;
					y1 = -MAXX * 2;
					x1 = (-m.c - m.b * y1) / m.a;
					if (x1 >= -MAXX * 2 - EPS && x1 <= MAXX * 2 + EPS)v.pb(mp(x1, y1));
					if (v.size() == 2)
						break;
					y1 = MAXX * 2;
					x1 = (-m.c - m.b * y1) / m.a;
					if (x1 >= -MAXX * 2 - EPS && x1 <= MAXX * 2 + EPS)v.pb(mp(x1, y1));
					if (v.size() == 2)
						break;
					throw;
				}
				x1 = v[0].x, y1 = v[0].y;
				x2 = v[1].x, y2 = v[1].y;
			}
		}
		//cout << x1+1e-19 << " " << y1+1e-19 << " " << x2+1e-19 << " " << y2+1e-19 << "\n";
	}

	cerr << clock() << endl;

	return 0;
}